#!/usr/bin/python


# Pygtk frontend for creating Freerdp launchers
# Author: Tony Brijeski
# Email: <tb6517@yahoo.com>
# Copyright 2013 GPLv2

import gtk
import os
import stat
import sys


class mainwin(gtk.Window):

    def which(self,file):
        for path in os.environ["PATH"].split(":"):
            if os.path.exists(path + "/" + file):
                return path + "/" + file

        return None

    def close(self,widget,event,data = None):
        self.hide()
        gtk.main_quit()
        return gtk.FALSE

    def prep(self,widget,option):
        print widget, option
        
        STERM = self.which("gnome-terminal")
        if STERM == "":
            STERM = self.which("xterm")
            
        
        SRDESKTOP = self.rdpprog.entry.get_text()
        print SRDESKTOP
        
        URLIP = self.urlentry.get_text()
        print URLIP
        if URLIP == "":
            self.hide()
            dialog = gtk.MessageDialog(self,gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "URL or IP Empty.\n\nField can't be empty")
            dialog.run()
            dialog.destroy()	
            self.show()
            return None
        
        USERNAME = self.userentry.get_text()
        if USERNAME == "":
            SUSERNAME = ""
        else:
            SUSERNAME = " -u " + USERNAME
        print SUSERNAME
        
        PASSWORD = self.passentry.get_text()
        if PASSWORD == "":
            SPASSWORD = ""
        else:
            SPASSWORD = " -p " + PASSWORD
        print SPASSWORD

        DOMAIN = self.domainentry.get_text()
        if DOMAIN == "":
            SDOMAIN = ""
        else:
            SDOMAIN = " -d " + DOMAIN
        print SDOMAIN
        
        FULLSCREEN = self.fullscreen.get_active()
        if FULLSCREEN == True:
            SFULLSCREEN = " -f "
        else:
            SFULLSCREEN = ""
        print SFULLSCREEN
        
        GEOMETRY = self.geomentry.get_text()
        if GEOMETRY == "":
            SGEOMETRY = ""
        else:
            SGEOMETRY = " -g " + GEOMETRY
        print SGEOMETRY
        
        BPP = self.bppentry.get_text()
        if BPP == "":
            SBPP = ""
        else:
            SBPP = " -a " + BPP
        print SBPP
        
        Runrdp = STERM + " -e \"" + SRDESKTOP + " " + SUSERNAME + SPASSWORD + SDOMAIN + SFULLSCREEN + SGEOMETRY + SBPP + " " + URLIP + "\"\n"
        print Runrdp
        if option == "Run":
            os.system(Runrdp + " &")
            self.show()
            return None
        else:
            RFILENAME = os.environ['HOME'] + "/." + SRDESKTOP + "-" + URLIP
            DFILENAME = os.environ['HOME'] + "/Desktop/" + SRDESKTOP + "-" + URLIP + ".desktop"
            print DFILENAME
            print RFILENAME
            RCONT = open(RFILENAME, 'w+')
            RCONT.write(Runrdp)
            RCONT.close()
            os.chmod(RFILENAME, stat.S_IRWXU)

            DFILECONTENTS = '''
[Desktop Entry]
Version=1.0
Type=Application
Name=RDP-%(URLIP)s
Comment=
Exec=%(RFILENAME)s
Icon=gnome-fs-network
Path=
Terminal=false
StartupNotify=false
''' % ({
            "URLIP" : URLIP,
            "RFILENAME" : RFILENAME
            })
            DCONT = open(DFILENAME, 'w+')
            DCONT.write(DFILECONTENTS)
            DCONT.close()
            os.chmod(DFILENAME, stat.S_IRWXU)
            self.hide()
            dialog = gtk.MessageDialog(self,gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_INFO, gtk.BUTTONS_OK, "RDP-" + URLIP + "\n\nLauncher Created on your Desktop")
            dialog.run()
            dialog.destroy()
            self.show()	
            return None
        
    
    def __init__(self):
        super(mainwin, self).__init__()
        
        self.set_title("RDP Launcher Creator")
        self.set_size_request(350, 400)
        self.set_position(gtk.WIN_POS_CENTER)
        
        win = gtk.Fixed()

        self.rdpprog = gtk.Combo()
        self.rdplabel = gtk.Label("Program")
        self.rdpprog.entry.set_text("xfreerdp")
        slist = [ "xfreerdp", "rdesktop" ]
        self.rdpprog.set_popdown_strings(slist)

        self.urllabel = gtk.Label("URL or IP:")
        self.urlentry = gtk.Entry()
        
        self.userlabel = gtk.Label("Username:")
        self.userentry = gtk.Entry()
        
        self.passlabel = gtk.Label("Password:")
        self.passentry = gtk.Entry()
        self.passentry.set_visibility(False)
        
        self.domainlabel = gtk.Label("Domain:")
        self.domainentry = gtk.Entry()
        
        self.fullscreen = gtk.CheckButton("Fullscreen")
        
        self.geomlabel = gtk.Label("Geometry:")
        self.geomentry = gtk.Entry()
        
        self.bpplabel = gtk.Label("Bits Per Pixel:")
        self.bppentry = gtk.Entry()
        
        self.savebutton = gtk.Button("Save")
        self.runbutton = gtk.Button("Connect")
        self.exitbutton = gtk.Button("Exit")

        self.exitbutton.connect("clicked", self.close, "Exit")
        self.savebutton.connect("clicked", self.prep, "Save")
        self.runbutton.connect("clicked", self.prep, "Run")

        win.put(self.rdpprog, 150, 30)
        win.put(self.rdplabel, 50, 35)

        win.put(self.urllabel, 50, 80)
        win.put(self.urlentry, 150, 75)
        
        win.put(self.userlabel, 50, 120)
        win.put(self.userentry, 150, 115)
        
        win.put(self.passlabel, 50, 160)
        win.put(self.passentry, 150, 155)
        
        win.put(self.domainlabel, 50, 200)
        win.put(self.domainentry, 150, 195)
        
        win.put(self.fullscreen, 50, 235)
        
        win.put(self.geomlabel, 50, 280)
        win.put(self.geomentry, 150, 275)
        
        win.put(self.bpplabel, 50, 320)
        win.put(self.bppentry, 150, 315)

        win.put(self.savebutton, 200, 360)
        win.put(self.runbutton, 250, 360)
        win.put(self.exitbutton, 50, 360)
                        
        self.add(win)
        
        self.connect("destroy", gtk.main_quit)
        self.show_all()

if __name__ == '__main__':
        
    mainwin()
    gtk.main()
